<?php
if (!defined('ABSPATH')) {
    exit;
}
if (!class_exists('Ecofa_Customize')) {

    class Ecofa_Customize {


        public function __construct() {
            add_action('customize_register', array($this, 'customize_register'));
        }

        public function get_banner() {
            global $post;

            $options[''] = esc_html__('Select Banner', 'ecofa');
            if (!ecofa_is_elementor_activated()) {
                return;
            }
            $args = array(
                'post_type'      => 'elementor_library',
                'posts_per_page' => -1,
                'orderby'        => 'title',
                's'              => 'Banner ',
                'order'          => 'ASC',
            );

            $query1 = new WP_Query($args);
            while ($query1->have_posts()) {
                $query1->the_post();
                $options[$post->post_name] = $post->post_title;
            }

            wp_reset_postdata();
            return $options;
        }

        /**
         * @param $wp_customize WP_Customize_Manager
         */
        public function tesst($wp_customize) {
            $wp_customize->add_control(
                new WP_Customize_Image_Control(
                    $wp_customize,
                    'dav_bgImage',
                    array(
                        'label'    => esc_attr__('Background image', 'ecofa'),
                        'section'  => 'dav_display_options',
                        'settings' => 'dav_bgImage',
                        'priority' => 8
                    )
                )
            );
        }

        public function customize_register($wp_customize) {

            /**
             * Theme options.
             */
            require_once get_theme_file_path('inc/customize-control/editor.php');
            $this->init_ecofa_blog($wp_customize);
            $this->ecofa_register_theme_customizer($wp_customize);


            if (ecofa_is_give_activated()) {

                $this->init_ecofa_give($wp_customize);
            }

            do_action('ecofa_customize_register', $wp_customize);
        }

        function ecofa_register_theme_customizer($wp_customize) {

        } // end ecofa_register_theme_customizer

        /**
         * @param $wp_customize WP_Customize_Manager
         *
         * @return void
         */
        public function init_ecofa_blog($wp_customize) {

            $wp_customize->add_panel('ecofa_blog', array(
                'title' => esc_html__('Blog', 'ecofa'),
            ));

            // =========================================
            // Blog Archive
            // =========================================
            $wp_customize->add_section('ecofa_blog_archive', array(
                'title'      => esc_html__('Archive', 'ecofa'),
                'panel'      => 'ecofa_blog',
                'capability' => 'edit_theme_options',
            ));

            $wp_customize->add_setting('ecofa_options_blog_sidebar', array(
                'type'              => 'option',
                'default'           => 'left',
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_blog_sidebar', array(
                'section' => 'ecofa_blog_archive',
                'label'   => esc_html__('Sidebar Position', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    'none'  => esc_html__('None', 'ecofa'),
                    'left'  => esc_html__('Left', 'ecofa'),
                    'right' => esc_html__('Right', 'ecofa'),
                ),
            ));

            $wp_customize->add_setting('ecofa_options_blog_style', array(
                'type'              => 'option',
                'default'           => 'standard',
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_blog_style', array(
                'section' => 'ecofa_blog_archive',
                'label'   => esc_html__('Blog style', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    'standard' => esc_html__('Blog Standard', 'ecofa'),
                    'list'     => esc_html__('Blog List', 'ecofa'),
                    'style-1'  => esc_html__('Blog Grid', 'ecofa'),
                ),
            ));

            $wp_customize->add_setting('ecofa_options_blog_columns', array(
                'type'              => 'option',
                'default'           => 3,
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_blog_columns', array(
                'section' => 'ecofa_blog_archive',
                'label'   => esc_html__('Colunms', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    1 => esc_html__('1', 'ecofa'),
                    2 => esc_html__('2', 'ecofa'),
                    3 => esc_html__('3', 'ecofa'),
                    4 => esc_html__('4', 'ecofa'),
                ),
            ));

            $wp_customize->add_setting('ecofa_options_blog_columns_laptop', array(
                'type'              => 'option',
                'default'           => 3,
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_blog_columns_laptop', array(
                'section' => 'ecofa_blog_archive',
                'label'   => esc_html__('Colunms Laptop', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    1 => esc_html__('1', 'ecofa'),
                    2 => esc_html__('2', 'ecofa'),
                    3 => esc_html__('3', 'ecofa'),
                    4 => esc_html__('4', 'ecofa'),
                ),
            ));

            $wp_customize->add_setting('ecofa_options_blog_columns_tablet', array(
                'type'              => 'option',
                'default'           => 2,
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_blog_columns_tablet', array(
                'section' => 'ecofa_blog_archive',
                'label'   => esc_html__('Colunms Tablet', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    1 => esc_html__('1', 'ecofa'),
                    2 => esc_html__('2', 'ecofa'),
                    3 => esc_html__('3', 'ecofa'),
                    4 => esc_html__('4', 'ecofa'),
                ),
            ));

            $wp_customize->add_setting('ecofa_options_blog_columns_mobile', array(
                'type'              => 'option',
                'default'           => 1,
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_blog_columns_mobile', array(
                'section' => 'ecofa_blog_archive',
                'label'   => esc_html__('Colunms Mobile', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    1 => esc_html__('1', 'ecofa'),
                    2 => esc_html__('2', 'ecofa'),
                    3 => esc_html__('3', 'ecofa'),
                    4 => esc_html__('4', 'ecofa'),
                ),
            ));

            // =========================================
            // Blog Single
            // =========================================
            $wp_customize->add_section('ecofa_blog_single', array(
                'title'      => esc_html__('Singular', 'ecofa'),
                'panel'      => 'ecofa_blog',
                'capability' => 'edit_theme_options',
            ));
            $wp_customize->add_setting('ecofa_options_blog_single_sidebar', array(
                'type'              => 'option',
                'default'           => 'left',
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_blog_single_sidebar', array(
                'section' => 'ecofa_blog_single',
                'label'   => esc_html__('Sidebar Position', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    'none'  => esc_html__('None', 'ecofa'),
                    'left'  => esc_html__('Left', 'ecofa'),
                    'right' => esc_html__('Right', 'ecofa'),
                ),
            ));
        }


        /**
         * @param $wp_customize WP_Customize_Manager
         *
         * @return void
         */
        public function init_ecofa_give($wp_customize) {

            $wp_customize->add_panel('give', array(
                'title' => esc_html__('Give', 'ecofa'),
            ));

            ///Archive
            $wp_customize->add_section('ecofa_give_archive', array(
                'title'      => esc_html__('Archive', 'ecofa'),
                'capability' => 'edit_theme_options',
                'panel'      => 'give',
                'priority'   => 1,
            ));

            $wp_customize->add_setting('ecofa_options_give_page', array(
                'type'              => 'option',
                'default'           => 'donnate',
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_give_page', array(
                'section' => 'ecofa_give_archive',
                'label'   => __('Donnate Page', 'ecofa'),
                'type'    => 'dropdown-pages',
            ));

            $wp_customize->add_setting('ecofa_options_give_archive_layout', array(
                'type'              => 'option',
                'default'           => 'grid',
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_give_archive_layout', array(
                'section' => 'ecofa_give_archive',
                'label'   => esc_html__('Style', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    'grid' => esc_html__('Grid', 'ecofa'),
                    'list' => esc_html__('List', 'ecofa'),
                ),
            ));

            $wp_customize->add_setting('ecofa_options_give_archive_column', array(
                'type'              => 'option',
                'default'           => '3',
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_give_archive_column', array(
                'section' => 'ecofa_give_archive',
                'label'   => esc_html__('Column', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    '1' => __('1', 'ecofa'),
                    '2' => __('2', 'ecofa'),
                    '3' => __('3', 'ecofa'),
                    '4' => __('4', 'ecofa'),
                ),
            ));
            $wp_customize->add_setting('ecofa_options_give_forms_per_page', array(
                'type'              => 'option',
                'default'           => '12',
                'sanitize_callback' => 'sanitize_text_field',
            ));

            $wp_customize->add_control('ecofa_options_give_forms_per_page', array(
                'section' => 'ecofa_give_archive',
                'label'   => esc_html__('Forms Per Page', 'ecofa'),
                'type'    => 'number',
            ));

            $wp_customize->add_setting('ecofa_options_give_archive_sidebar', array(
                'type'              => 'option',
                'default'           => 'left',
                'sanitize_callback' => 'sanitize_text_field',
            ));
            $wp_customize->add_control('ecofa_options_give_archive_sidebar', array(
                'section' => 'ecofa_give_archive',
                'label'   => esc_html__('Sidebar Position', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    'none'  => esc_html__('None', 'ecofa'),
                    'left'  => esc_html__('Left', 'ecofa'),
                    'right' => esc_html__('Right', 'ecofa'),
                ),
            ));

            ///single
            $wp_customize->add_section('ecofa_give_single', array(
                'title'      => esc_html__('Single', 'ecofa'),
                'capability' => 'edit_theme_options',
                'panel'      => 'give',
                'priority'   => 1,
            ));
            $wp_customize->add_setting('ecofa_options_give_single_sidebar', array(
                'type'              => 'option',
                'default'           => 'left',
                'sanitize_callback' => 'sanitize_text_field',
            ));
            $wp_customize->add_control('ecofa_options_give_single_sidebar', array(
                'section' => 'ecofa_give_single',
                'label'   => esc_html__('Sidebar Position', 'ecofa'),
                'type'    => 'select',
                'choices' => array(
                    'left'  => esc_html__('Left', 'ecofa'),
                    'right' => esc_html__('Right', 'ecofa'),
                ),
            ));
        }
    }
}
return new Ecofa_Customize();
