<?php
use Elementor\Controls_Manager;

add_action( 'elementor/element/social-icons/section_social_style/before_section_end', function ($element, $args ) {

	$element->add_control(
		'icon_social_margin',
		[
			'label' => esc_html__( 'Margin', 'ecofa' ),
			'type'       => Controls_Manager::DIMENSIONS,
			'range' => '',
			'size_units' => [ 'px', 'em', '%' ],
			'selectors' => [
				'{{WRAPPER}} .elementor-grid-item' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
			],
		]
	);

}, 10, 2 );

add_action( 'elementor/element/social-icons/section_social_icon/before_section_end', function ($element, $args ) {
    $element->add_control(
        'socical_enable_effects',
        [
            'label'     => esc_html__('Effects', 'ecofa'),
            'type'      => Controls_Manager::SWITCHER,
            'prefix_class' => 'enable-effects-',
        ]
    );
    $element->add_control(
        'effects_color',
        [
            'label'     => esc_html__('Effects color', 'ecofa'),
            'type'      => Controls_Manager::COLOR,
            'default'   => '',
            'selectors' => [
                '{{WRAPPER}}.enable-effects-yes .elementor-social-icon ' => 'background-color:{{VALUE}};',
            ]
        ]
    );
    $element->add_control(
        'effects_width_icon',
        [
            'label'          => esc_html__('Width Effects', 'ecofa'),
            'type'           => Controls_Manager::SLIDER,
            'default'        => [
                'unit' => '%',
            ],
            'tablet_default' => [
                'unit' => '%',
            ],
            'mobile_default' => [
                'unit' => '%',
            ],
            'size_units'     => ['%', 'px', 'vw'],
            'range'          => [
                '%'  => [
                    'min' => 1,
                    'max' => 100,
                ],
                'px' => [
                    'min' => 1,
                    'max' => 1000,
                ],
                'vw' => [
                    'min' => 1,
                    'max' => 100,
                ],
            ],
            'selectors'      => [
                '{{WRAPPER}}.enable-effects-yes .elementor-social-icon ' => 'width: {{SIZE}}{{UNIT}};',
            ],
        ]
    );
    $element->add_control(
        'effects_height_icon',
        [
            'label'          => esc_html__('Height Effects', 'ecofa'),
            'type'           => Controls_Manager::SLIDER,
            'default'        => [
                'unit' => '%',
            ],
            'tablet_default' => [
                'unit' => '%',
            ],
            'mobile_default' => [
                'unit' => '%',
            ],
            'size_units'     => ['%', 'px', 'vw'],
            'range'          => [
                '%'  => [
                    'min' => 1,
                    'max' => 100,
                ],
                'px' => [
                    'min' => 1,
                    'max' => 1000,
                ],
                'vw' => [
                    'min' => 1,
                    'max' => 100,
                ],
            ],
            'selectors'      => [
                '{{WRAPPER}}.enable-effects-yes .elementor-social-icon ' => 'height: {{SIZE}}{{UNIT}};',
            ],
        ]
    );
}, 10, 2 );
