<?php

if (!function_exists('ecofa_single_give_content_start')) {
    function ecofa_single_give_content_start() {
        echo '<div class="single-give-content-wrap">';
    }
}

if (!function_exists('ecofa_single_give_content_end')) {
    function ecofa_single_give_content_end() {
        echo '</div>';
    }
}

if (!function_exists('ecofa_single_give_summary_right_start')) {
    function ecofa_single_give_summary_right_start() {
        echo '<div class="entry-summary-right">';
    }
}

if (!function_exists('ecofa_single_give_summary_right_end')) {
    function ecofa_single_give_summary_right_end() {
        echo '</div>';
    }
}

if (!function_exists('ecofa_single_give_summary_inner_start')) {
    function ecofa_single_give_summary_inner_start() {
        echo '<div class="give-summary-inner">';
    }
}

if (!function_exists('ecofa_single_give_summary_inner_end')) {
    function ecofa_single_give_summary_inner_end() {
        echo '</div>';
    }
}

//give_donation_form_top
if (!function_exists('ecofa_single_give_donation_title')) {
    function ecofa_single_give_donation_title() {
        echo '<h3 class="single-give-donation-title">' . esc_html__('Your Donation', 'ecofa') . '</h3>';
    }
}

if (!function_exists('ecofa_single_give_excerpt')) {
    function ecofa_single_give_excerpt() {
        $atts['excerpt_length'] = apply_filters('ecofa_single_give_excerpt_length', 25);
        $form_id                = get_the_ID();
        if ($raw_content = get_the_excerpt($form_id)) {
            $stripped_content = wp_strip_all_tags(
                strip_shortcodes($raw_content)
            );
        } else {
            // Get content from the form post's content field.
            $raw_content = give_get_meta($form_id, '_give_form_content', true);

            if (!empty($raw_content)) {
                $stripped_content = wp_strip_all_tags(
                    strip_shortcodes($raw_content)
                );
            }
        }

        // Maybe truncate excerpt.
        if (0 < $atts['excerpt_length']) {
            $excerpt = wp_trim_words($stripped_content, $atts['excerpt_length']);
        } else {
            $excerpt = $stripped_content;
        }

        $excerpt = ($excerpt === '[]') ? '' : $excerpt;

        printf('<p class="give-form-grid-content__text">%s</p>', $excerpt);
    }
}

if (!function_exists('ecofa_single_give_summary_tab')) {
    function ecofa_single_give_summary_tab() {
        wp_enqueue_script("jquery-ui-tabs");
        $gallery       = ecofa_get_post_meta(get_the_ID(), '_give_image_gallery');
        $content_check = give_is_setting_enabled(give_get_meta(get_the_ID(), '_give_display_content', true));
        $form          = new Give_Donate_Form(get_the_ID());
        ?>
        <div id="give-form-single-tab" class="give-form-tabs">
            <ul>
                <?php if ($content_check): ?>
                    <li><a href="#tabs-description"><?php echo esc_html__('description', 'ecofa'); ?></a></li>
                <?php endif; ?>

                <li><a href="#tabs-donor"><?php echo esc_html__('donors', 'ecofa'); ?>
                        <span>(<?php printf('%s', $form->get_sales()); ?>)</span></a></li>

                <?php if ($gallery) {
                    echo '<li><a href="#tabs-gallery">' . esc_html__('gallery', 'ecofa') . '</a></li>';
                } ?>
            </ul>
            <?php if ($content_check): ?>
                <div id="tabs-description">
                    <?php give_form_display_content(get_the_ID(), []); ?>
                </div>
            <?php endif;
            if ($gallery) {
                echo '<div id="tabs-gallery">' . do_shortcode('[gallery link="file" columns="4"  size="ecofa-featured-image-small" ids="' . $gallery . '"]') . '</div>';
            }
            ?>
            <div id="tabs-donor">
                <?php echo do_shortcode('[give_donor_wall form_id="' . get_the_ID() . '" columns = 4 avatar_size = 80 show_time =false]');
                ?>
            </div>
        </div>
        <?php
    }
}
if (!function_exists('ecofa_give_categories')) {
    function ecofa_give_categories() {
        $form_id         = get_the_ID();
        $enable_category = give_is_setting_enabled(give_get_option('categories', 'disabled'));
        if ($enable_category) {
            $term_list = wp_get_post_terms($form_id, 'give_forms_category', array('fields' => 'id=>name'));
        }

        if (!empty($term_list)): ?>
            <div class="give-card__category"><?php if (is_array($term_list)):
                    foreach ($term_list as $key => $value) {
                        echo '<span>' . esc_html($value) . '</span>';
                    }
                endif; ?>
            </div>
        <?php endif;
    }
}
if (!function_exists('ecofa_give_show_goal_progress')) {
    function ecofa_give_show_goal_progress() {
        $form_id = get_the_ID();
        give_show_goal_progress($form_id, ['show_bar' => true, 'goal_text_style' => true]);
    }
}
if (!function_exists('ecofa_give_meta')) {

    function ecofa_give_meta() {
        ?>
        <div class="give-grid-meta">
            <?php
            $time_string = '<time class="entry-date published" datetime="%1$s">%2$s</time>';

            if (get_the_time('U') !== get_the_modified_time('U')) {
                $time_string = '<time class="entry-date published" datetime="%1$s">%2$s</time><time class="updated" datetime="%3$s">%4$s</time>';
            }

            $time_string = sprintf(
                $time_string,
                esc_attr(get_the_date('c')),
                esc_html(get_the_date()),
                esc_attr(get_the_modified_date('c')),
                esc_html(get_the_modified_date())
            );

            $posted_on = '<span class="posted-on">' . sprintf('<a href="%1$s" rel="bookmark">%2$s</a>', esc_url(get_permalink()), $time_string) . '</span>';

            // Author.
            $author = sprintf(
                '<span class="post-author">%1$s<a href="%2$s" class="url fn" rel="author">%3$s</a></span>',
                esc_html__('by ', 'ecofa'),
                esc_url(get_author_posts_url(get_the_author_meta('ID'))),
                esc_html(get_the_author())
            );


            echo wp_kses(
                sprintf('%1$s - %2$s', $author, $posted_on), array(
                    'span' => array(
                        'class' => array(),
                    ),
                    'a'    => array(
                        'href'  => array(),
                        'title' => array(),
                        'rel'   => array(),
                    ),
                    'time' => array(
                        'datetime' => array(),
                        'class'    => array(),
                    ),
                )
            );
            ?>

        </div>
        <?php
    }
}

function ecofa_give_sidebar($arg) {
    $arg['before_title'] = '<h3 class="widgettitle widget-title"><span>';
    $arg['after_title']  = '</span></h3>';
    return $arg;
}

add_filter('give_default_wrapper_start', function () {
    return '<div id="container" class="give-wrap"><div id="content-give" role="main">';
});