<?php

class Ecofa_Merlin_Config {

    private $wizard;

    public function __construct() {
        $this->init();
        add_filter('merlin_import_files', [$this, 'import_files']);
        add_action('merlin_after_all_import', [$this, 'after_import_setup'], 10, 1);
        add_filter('merlin_generate_child_functions_php', [$this, 'render_child_functions_php']);

        add_action('import_start', function () {
            add_filter('wxr_importer.pre_process.post_meta', [$this, 'fiximport_elementor'], 10, 1);
        });

        add_action('import_end', function () {
            update_option('elementor_experiment-container', 'active');
            update_option('elementor_experiment-nested-elements', 'active');
        });
    }

    public function fiximport_elementor($post_meta) {
        if ('_elementor_data' === $post_meta['key']) {
            $post_meta['value'] = wp_slash($post_meta['value']);
        }

        return $post_meta;
    }

    public function import_files() {
            
        return array(
            array(
                'import_file_name'           => 'home 1',
                'home'                       => 'home-1',
                'local_import_file'          => get_theme_file_path('/dummy-data/content.xml'),
                'homepage'                   => get_theme_file_path('/dummy-data/homepage/home-1.xml'),
                'local_import_widget_file'   => get_theme_file_path('/dummy-data/widgets.json'),
                'import_rev_slider_file_url' => 'http://source.wpopal.com/ecofa/dummy_data/revsliders/home-1/slider-1.zip',
                'import_more_revslider_file_url' => [],
                'import_lookbook_revslider_file_url' => [],
                'import_preview_image_url'   => get_theme_file_uri('/assets/images/oneclick/home-1.jpg'),
                'preview_url'                => 'https://demo2.pavothemes.com/ecofa/home-1',
                'elementor'                  => '{"system_colors":[{"_id":"primary","title":"Primary","color":"#139C63"},{"_id":"secondary","title":"Secondary(Heading)","color":"#3E676E"},{"_id":"text","title":"Text","color":"#333333"},{"_id":"accent","title":"Accent","color":"#002539"},{"_id":"border","title":"Border","color":"#E1E1E1"},{"_id":"lighter","title":"Lighter","color":"#8F8F8F"},{"_id":"dark","title":"Dark","color":"#000000"}],"custom_colors":[],"system_typography":[{"_id":"primary","title":"Primary","typography_typography":"custom"},{"_id":"secondary","title":"Secondary(Heading)","typography_typography":"custom"},{"_id":"tertiary","title":"Tertiary","typography_typography":"custom"},{"_id":"text","title":"Text","typography_typography":"custom"},{"_id":"accent","title":"Accent","typography_typography":"custom"}],"custom_typography":[],"default_generic_fonts":"Sans-serif","site_name":"Ecofa","site_description":"Environment Protection Nonprofits WordPress Theme","page_title_selector":"h1.entry-title","activeItemIndex":1,"active_breakpoints":["viewport_mobile","viewport_mobile_extra","viewport_tablet","viewport_tablet_extra","viewport_laptop"],"viewport_md":768,"viewport_lg":1025,"container_width":{"unit":"px","size":1290,"sizes":[]},"space_between_widgets":{"unit":"px","size":0,"sizes":[]},"body_background_background":"classic","body_background_color":"#fff","viewport_laptop":1440}',
                'themeoptions'               => '{}',
            ),

            array(
                'import_file_name'           => 'home 2',
                'home'                       => 'home-2',
                'local_import_file'          => get_theme_file_path('/dummy-data/content.xml'),
                'homepage'                   => get_theme_file_path('/dummy-data/homepage/home-2.xml'),
                'local_import_widget_file'   => get_theme_file_path('/dummy-data/widgets.json'),
                'import_rev_slider_file_url' => 'http://source.wpopal.com/ecofa/dummy_data/revsliders/home-2/slider-2.zip',
                'import_more_revslider_file_url' => [],
                'import_lookbook_revslider_file_url' => [],
                'import_preview_image_url'   => get_theme_file_uri('/assets/images/oneclick/home-2.jpg'),
                'preview_url'                => 'https://demo2.pavothemes.com/ecofa/home-2',
                'elementor'                  => '{"system_colors":[{"_id":"primary","title":"Primary","color":"#139C63"},{"_id":"secondary","title":"Secondary(Heading)","color":"#3E676E"},{"_id":"text","title":"Text","color":"#333333"},{"_id":"accent","title":"Accent","color":"#002539"},{"_id":"border","title":"Border","color":"#E1E1E1"},{"_id":"lighter","title":"Lighter","color":"#8F8F8F"},{"_id":"dark","title":"Dark","color":"#000000"}],"custom_colors":[],"system_typography":[{"_id":"primary","title":"Primary","typography_typography":"custom"},{"_id":"secondary","title":"Secondary(Heading)","typography_typography":"custom"},{"_id":"tertiary","title":"Tertiary","typography_typography":"custom"},{"_id":"text","title":"Text","typography_typography":"custom"},{"_id":"accent","title":"Accent","typography_typography":"custom"}],"custom_typography":[],"default_generic_fonts":"Sans-serif","site_name":"Ecofa","site_description":"Environment Protection Nonprofits WordPress Theme","page_title_selector":"h1.entry-title","activeItemIndex":1,"active_breakpoints":["viewport_mobile","viewport_mobile_extra","viewport_tablet","viewport_tablet_extra","viewport_laptop"],"viewport_md":768,"viewport_lg":1025,"container_width":{"unit":"px","size":1290,"sizes":[]},"space_between_widgets":{"unit":"px","size":0,"sizes":[]},"body_background_background":"classic","body_background_color":"#fff","viewport_laptop":1440}',
                'themeoptions'               => '{}',
            ),

            array(
                'import_file_name'           => 'home 3',
                'home'                       => 'home-3',
                'local_import_file'          => get_theme_file_path('/dummy-data/content.xml'),
                'homepage'                   => get_theme_file_path('/dummy-data/homepage/home-3.xml'),
                'local_import_widget_file'   => get_theme_file_path('/dummy-data/widgets.json'),
                'import_rev_slider_file_url' => 'http://source.wpopal.com/ecofa/dummy_data/revsliders/home-3/slider-3.zip',
                'import_more_revslider_file_url' => [],
                'import_lookbook_revslider_file_url' => [],
                'import_preview_image_url'   => get_theme_file_uri('/assets/images/oneclick/home-3.jpg'),
                'preview_url'                => 'https://demo2.pavothemes.com/ecofa/home-3',
                'elementor'                  => '{"system_colors":[{"_id":"primary","title":"Primary","color":"#139C63"},{"_id":"secondary","title":"Secondary(Heading)","color":"#3E676E"},{"_id":"text","title":"Text","color":"#333333"},{"_id":"accent","title":"Accent","color":"#002539"},{"_id":"border","title":"Border","color":"#E1E1E1"},{"_id":"lighter","title":"Lighter","color":"#8F8F8F"},{"_id":"dark","title":"Dark","color":"#000000"}],"custom_colors":[],"system_typography":[{"_id":"primary","title":"Primary","typography_typography":"custom"},{"_id":"secondary","title":"Secondary(Heading)","typography_typography":"custom"},{"_id":"tertiary","title":"Tertiary","typography_typography":"custom"},{"_id":"text","title":"Text","typography_typography":"custom"},{"_id":"accent","title":"Accent","typography_typography":"custom"}],"custom_typography":[],"default_generic_fonts":"Sans-serif","site_name":"Ecofa","site_description":"Environment Protection Nonprofits WordPress Theme","page_title_selector":"h1.entry-title","activeItemIndex":1,"active_breakpoints":["viewport_mobile","viewport_mobile_extra","viewport_tablet","viewport_tablet_extra","viewport_laptop"],"viewport_md":768,"viewport_lg":1025,"container_width":{"unit":"px","size":1290,"sizes":[]},"space_between_widgets":{"unit":"px","size":0,"sizes":[]},"body_background_background":"classic","body_background_color":"#fff","viewport_laptop":1440}',
                'themeoptions'               => '{}',
            ),

        );           
    }// end import_files

    private function setup_give() {
        $params    = array(
            'posts_per_page' => -1,
            'post_type'      => [
                'give_forms',
            ],
        );
        $list_goal = [
            7000,
            15000,
            6000,
            8000,
            10000,
            12000,
            7500,
            14000
        ];
        $query     = new WP_Query($params);
        while ($query->have_posts()): $query->the_post();
            $goal    = $list_goal[rand(0, 7)];
            $earning = absint($goal) * rand(30, 100) / 100;
            set_post_thumbnail(get_the_ID(), $this->get_attachment('_placeholder'));
            wp_update_post([
                'ID'          => get_the_ID(),
                'post_status' => 'publish',
                'post_type'   => 'give_forms',
                'post_date'   => $this->get_date(),
                'meta_input'  => [
                    '_give_onboarding_default_form'             => 1,
                    '_give_levels_minimum_amount'               => 10,
                    '_give_levels_maximim_amount'               => 250,
                    '_give_form_template'                       => 'legacy',
                    '_give_form_status'                         => 'open',
                    '_give_sequoia_form_template_settings'      => $this->getTemplateConfig(),
                    '_give_checkout_label'                      => __('Donate Now', 'ecofa'),
                    '_give_display_style'                       => 'buttons',
                    '_give_payment_display'                     => 'onpage',
                    '_give_form_floating_labels'                => 'disabled',
                    '_give_reveal_label'                        => __('Donate Now', 'ecofa'),
                    '_give_display_content'                     => 'enabled',
                    '_give_content_placement'                   => 'give_post_form',
                    '_give_form_content'                        => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras non nisi a tortor imperdiet varius ut eget ligula. Praesent mollis ante vitae augue tincidunt egestas. Suspendisse faucibus felis metus, et viverra risus facilisis quis. Integer et vehicula velit, quis malesuada magna. Maecenas faucibus sed tortor quis scelerisque. Vivamus commodo urna at magna facilisis, interdum interdum ligula aliquet. In ultrices, sem suscipit tempus facilisis, massa enim sodales massa, nec molestie sapien odio a arcu.',
                    '_give_price_option'                        => 'multi',
                    '_give_set_price'                           => 1,
                    '_give_custom_amount'                       => 'enabled',
                    '_give_donation_levels'                     => $this->getDonationLevels(),
                    '_give_default_gateway'                     => 'global',
                    '_give_name_title_prefix'                   => 'global',
                    '_give_title_prefixes'                      => '',
                    '_give_company_field'                       => 'global',
                    '_give_anonymous_donation'                  => 'global',
                    '_give_donor_comment'                       => 'global',
                    '_give_logged_in_only'                      => 'enabled',
                    '_give_show_register_form'                  => 'none',
                    '_give_goal_option'                         => 'enabled',
                    '_give_goal_format'                         => 'amount',
                    '_give_set_goal'                            => $list_goal[rand(0, 7)],
                    '_give_form_earnings'                       => $earning,
                    '_give_number_of_donor_goal'                => 100,
                    '_give_close_form_when_goal_achieved'       => 'enabled',
                    '_give_form_goal_achieved_message'          => __('Thank you to all our donors, we have met our fundraising goal.', 'ecofa'),
                    '_give_terms_option'                        => 'global',
                    '_give_agree_label'                         => __('Agree to terms?', 'ecofa'),
                    '_give_agree_text'                          => __('The terms can be customized in the donation form settings.', 'ecofa'),
                    'give_stripe_per_form_accounts'             => 'disabled', // Note: Doesn't use underscore prefix.
                    '_give_default_stripe_account'              => '',
                    '_give_email_options'                       => 'global',
                    '_give_email_template'                      => 'default',
                    '_give_email_logo'                          => '',
                    '_give_from_name'                           => get_bloginfo('name'),
                    '_give_from_email'                          => get_bloginfo('admin_email'),
                    '_give_new-donation_notification'           => 'global',
                    '_give_new-donation_email_subject'          => sprintf('%s - #{payment_id}', __('New Donation', 'ecofa')),
                    '_give_new-donation_email_header'           => __('New Donation!', 'ecofa'),
                    '_give_new-donation_email_message'          => give_get_default_donation_notification_email(),
                    '_give_new-donation_email_content_type'     => 'text/html',
                    '_give_new-donation_recipient'              => [
                        'email' => get_bloginfo('admin_email'),
                    ],
                    '_give_donation-receipt_notification'       => 'global',
                    '_give_donation-receipt_email_subject'      => __('Donation Receipt', 'ecofa'),
                    '_give_donation-receipt_email_header'       => __('Donation Receipt', 'ecofa'),
                    '_give_donation-receipt_email_mesage'       => give_get_default_donation_receipt_email(),
                    '_give_donation-receipt_email_content_type' => 'text/html',
                    '_give_form_goal_progress'                  => -1,
                    '_give_offline_checkout_notes'              => '<em>You can customize instructions in the forms settings.</em>'
                                                                   . '<br /><br />'
                                                                   . '<strong>Please make checks payable to "{sitename}".</strong>'
                                                                   . '<br /><br />'
                                                                   . 'Your donation is greatly appreciated!',
                ],
            ]);
        endwhile;
    }

    private function get_date() {
        $month    = $this->getRandom(rand(1, 7));
        $day      = $this->getRandom(rand(1, 30));
        $minute   = $this->getRandom(rand(1, 60));
        $datetime = "2020-{$month}-{$day} 03:{$minute}:40.000000";

        return $datetime;
    }

    private function getRandom($number) {
        if ($number < 10) {
            return '0' . $number;
        }

        return '' . $number;
    }

    private function getTemplateConfig() {
        return [
            'introduction'        => [
                'enabled'      => 'enabled',
                'headline'     => __('Support Our Cause', 'ecofa'),
                'description'  => __('Help our organization by donating today! All donations go directly to making a difference for our cause.', 'ecofa'),
                'image'        => GIVE_PLUGIN_URL . 'assets/dist/images/onboarding-preview-form-image.min.jpg',
                'donate_label' => __('Donate Now', 'ecofa'),
            ],
            'payment_amount'      => [
                'header_label' => __('Choose Amount', 'ecofa'),
                'content'      => sprintf(__('How much would you like to donate? As a contributor to %s we make sure your donation goes directly to supporting our cause.', 'ecofa'), get_bloginfo('sitename')),
                'next_label'   => __('Continue', 'ecofa'),
            ],
            'payment_information' => [
                'header_label' => __('Add Your Information', 'ecofa'),
                'headline'     => __("Who's giving today?", 'ecofa'),
                'description'  => __('We’ll never share this information with anyone.', 'ecofa'),
                \Give\Form\Template\Options::getCheckoutLabelField(),
            ],
            'thank-you'           => [
                'image'               => '',
                'headline'            => __('A great big thank you!', 'ecofa'),
                'description'         => __('{name}, your contribution means a lot and will be put to good use making a difference. We’ve sent your donation receipt to {donor_email}. ', 'ecofa'),
                'sharing'             => 'enabled',
                'sharing_instruction' => __('Help us out by sharing with friends and followers that you supported the cause!', 'ecofa'),
                'twitter_message'     => __("I just gave to this cause. Who's next?", 'ecofa'),
            ],
        ];
    }

    private function getDonationLevels() {
        return [
            [
                '_give_id'     =>
                    [
                        'level_id' => 0,
                    ],
                '_give_amount' => 10,
            ],
            [
                '_give_id'     =>
                    [
                        'level_id' => 1,
                    ],
                '_give_amount' => 25,
            ],
            [
                '_give_id'     =>
                    [
                        'level_id' => 2,
                    ],
                '_give_amount' => 50,
            ],
            [
                '_give_id'      =>
                    [
                        'level_id' => 3,
                    ],
                '_give_amount'  => 100,
                '_give_default' => 'default',
            ],
            [
                '_give_id'     =>
                    [
                        'level_id' => 5,
                    ],
                '_give_amount' => 250,
            ],
        ];
    }

    public function after_import_setup($selected_import) {
        $check_oneclick  = get_option('ecofa_check_oneclick', []);
        $selected_import = ($this->import_files())[$selected_import];

        // setup Home page
        $home = get_page_by_path($selected_import['home']);
        if ($home->ID) {
            update_option('show_on_front', 'page');
            update_option('page_on_front', $home->ID);
        }

        $this->set_demo_menus();

        // Setup Options
        $options       = $this->get_all_options();
        $theme_options = $options['options'];
        foreach ($theme_options as $key => $option) {
            update_option($key, $option);
        }

        $active_kit_id = Elementor\Plugin::$instance->kits_manager->get_active_id();
        update_post_meta($active_kit_id, '_elementor_page_settings', json_decode($selected_import['elementor'], true));
        set_theme_mod('custom_logo', $this->get_attachment('_logo'));

        // Header Footer Builder
        $this->reset_header_footer();
        $this->set_hf($selected_import['home']);
        if (!isset($check_oneclick['give'])) {
//            update_option('give_settings', $options['give']);
            give_update_option('form_sidebar', 'disabled');
            give_update_option('categories', 'enabled');
            give_update_option('tags', 'enabled');
            $this->setup_give();
            $check_oneclick['give'] = true;
        }
        \Elementor\Plugin::instance()->files_manager->clear_cache();

        $this->update_nav_menu_item();
        update_option('ecofa_check_oneclick', $check_oneclick);
    }

    private function update_nav_menu_item() {
        $params = array(
            'posts_per_page' => -1,
            'post_type'      => [
                'nav_menu_item',
            ],
        );
        $query  = new WP_Query($params);
        while ($query->have_posts()): $query->the_post();
            wp_update_post(array(
                // Update the `nav_menu_item` Post Title
                'ID'         => get_the_ID(),
                'post_title' => get_the_title()
            ));
        endwhile;

    }

    private function get_mailchimp_id() {
        $params = array(
            'post_type'      => 'mc4wp-form',
            'posts_per_page' => 1,
        );
        $post   = get_posts($params);

        return isset($post[0]) ? $post[0]->ID : 0;
    }

    private function get_attachment($key) {
        $params = array(
            'post_type'      => 'attachment',
            'post_status'    => 'inherit',
            'posts_per_page' => 1,
            'meta_key'       => $key,
        );
        $post   = get_posts($params);
        if ($post) {
            return $post[0]->ID;
        }

        return 0;
    }

    private function init() {
        $this->wizard = new Merlin(
            $config = array(
                // Location / directory where Merlin WP is placed in your theme.
                'merlin_url'         => 'merlin',
                // The wp-admin page slug where Merlin WP loads.
                'parent_slug'        => 'themes.php',
                // The wp-admin parent page slug for the admin menu item.
                'capability'         => 'manage_options',
                // The capability required for this menu to be displayed to the user.
                'dev_mode'           => true,
                // Enable development mode for testing.
                'license_step'       => false,
                // EDD license activation step.
                'license_required'   => false,
                // Require the license activation step.
                'license_help_url'   => '',
                'directory'          => '/inc/merlin',
                // URL for the 'license-tooltip'.
                'edd_remote_api_url' => '',
                // EDD_Theme_Updater_Admin remote_api_url.
                'edd_item_name'      => '',
                // EDD_Theme_Updater_Admin item_name.
                'edd_theme_slug'     => '',
                // EDD_Theme_Updater_Admin item_slug.
            ),
            $strings = array(
                'admin-menu'          => esc_html__('Theme Setup', 'ecofa'),

                /* translators: 1: Title Tag 2: Theme Name 3: Closing Title Tag */
                'title%s%s%s%s'       => esc_html__('%1$s%2$s Themes &lsaquo; Theme Setup: %3$s%4$s', 'ecofa'),
                'return-to-dashboard' => esc_html__('Return to the dashboard', 'ecofa'),
                'ignore'              => esc_html__('Disable this wizard', 'ecofa'),

                'btn-skip'                 => esc_html__('Skip', 'ecofa'),
                'btn-next'                 => esc_html__('Next', 'ecofa'),
                'btn-start'                => esc_html__('Start', 'ecofa'),
                'btn-no'                   => esc_html__('Cancel', 'ecofa'),
                'btn-plugins-install'      => esc_html__('Install', 'ecofa'),
                'btn-child-install'        => esc_html__('Install', 'ecofa'),
                'btn-content-install'      => esc_html__('Install', 'ecofa'),
                'btn-import'               => esc_html__('Import', 'ecofa'),
                'btn-license-activate'     => esc_html__('Activate', 'ecofa'),
                'btn-license-skip'         => esc_html__('Later', 'ecofa'),

                /* translators: Theme Name */
                'license-header%s'         => esc_html__('Activate %s', 'ecofa'),
                /* translators: Theme Name */
                'license-header-success%s' => esc_html__('%s is Activated', 'ecofa'),
                /* translators: Theme Name */
                'license%s'                => esc_html__('Enter your license key to enable remote updates and theme support.', 'ecofa'),
                'license-label'            => esc_html__('License key', 'ecofa'),
                'license-success%s'        => esc_html__('The theme is already registered, so you can go to the next step!', 'ecofa'),
                'license-json-success%s'   => esc_html__('Your theme is activated! Remote updates and theme support are enabled.', 'ecofa'),
                'license-tooltip'          => esc_html__('Need help?', 'ecofa'),

                /* translators: Theme Name */
                'welcome-header%s'         => esc_html__('Welcome to %s', 'ecofa'),
                'welcome-header-success%s' => esc_html__('Hi. Welcome back', 'ecofa'),
                'welcome%s'                => esc_html__('This wizard will set up your theme, install plugins, and import content. It is optional & should take only a few minutes.', 'ecofa'),
                'welcome-success%s'        => esc_html__('You may have already run this theme setup wizard. If you would like to proceed anyway, click on the "Start" button below.', 'ecofa'),

                'child-header'         => esc_html__('Install Child Theme', 'ecofa'),
                'child-header-success' => esc_html__('You\'re good to go!', 'ecofa'),
                'child'                => esc_html__('Let\'s build & activate a child theme so you may easily make theme changes.', 'ecofa'),
                'child-success%s'      => esc_html__('Your child theme has already been installed and is now activated, if it wasn\'t already.', 'ecofa'),
                'child-action-link'    => esc_html__('Learn about child themes', 'ecofa'),
                'child-json-success%s' => esc_html__('Awesome. Your child theme has already been installed and is now activated.', 'ecofa'),
                'child-json-already%s' => esc_html__('Awesome. Your child theme has been created and is now activated.', 'ecofa'),

                'plugins-header'         => esc_html__('Install Plugins', 'ecofa'),
                'plugins-header-success' => esc_html__('You\'re up to speed!', 'ecofa'),
                'plugins'                => esc_html__('Let\'s install some essential WordPress plugins to get your site up to speed.', 'ecofa'),
                'plugins-success%s'      => esc_html__('The required WordPress plugins are all installed and up to date. Press "Next" to continue the setup wizard.', 'ecofa'),
                'plugins-action-link'    => esc_html__('Advanced', 'ecofa'),

                'import-header'      => esc_html__('Import Content', 'ecofa'),
                'import'             => esc_html__('Let\'s import content to your website, to help you get familiar with the theme.', 'ecofa'),
                'import-action-link' => esc_html__('Advanced', 'ecofa'),

                'ready-header'      => esc_html__('All done. Have fun!', 'ecofa'),

                /* translators: Theme Author */
                'ready%s'           => esc_html__('Your theme has been all set up. Enjoy your new theme by %s.', 'ecofa'),
                'ready-action-link' => esc_html__('Extras', 'ecofa'),
                'ready-big-button'  => esc_html__('View your website', 'ecofa'),
                'ready-link-1'      => sprintf('<a href="%1$s" target="_blank">%2$s</a>', 'https://wordpress.org/support/', esc_html__('Explore WordPress', 'ecofa')),
                'ready-link-2'      => sprintf('<a href="%1$s" target="_blank">%2$s</a>', 'https://themebeans.com/contact/', esc_html__('Get Theme Support', 'ecofa')),
                'ready-link-3'      => sprintf('<a href="%1$s">%2$s</a>', admin_url('customize.php'), esc_html__('Start Customizing', 'ecofa')),
            )
        );
        if (ecofa_is_elementor_activated()) {
            add_action('widgets_init', [$this, 'widgets_init']);
        }
        if (class_exists('Monster_Widget')) {
            add_action('widgets_init', [$this, 'widget_monster']);
        }
    }

    public function widget_monster() {
        unregister_widget('Monster_Widget');
        require_once get_parent_theme_file_path('/inc/merlin/includes/monster-widget.php');
        register_widget('Ecofa_Monster_Widget');
    }

    public function widgets_init() {
        require_once get_parent_theme_file_path('/inc/merlin/includes/recent-post.php');
        register_widget('Ecofa_WP_Widget_Recent_Posts');
        if (ecofa_is_woocommerce_activated()) {
            require_once get_parent_theme_file_path('/inc/merlin/includes/class-wc-widget-layered-nav.php');
            register_widget('Ecofa_Widget_Layered_Nav');
        }
        if (ecofa_is_give_activated()) {
            require_once get_parent_theme_file_path('/inc/merlin/includes/class-wp-give-widget-categories.php');
            register_widget('Ecofa_Give_Widget_Categories');
        }
    }

    private function get_all_header_footer() {
        return [
            'home-1' => [
                'header' => [
                    [
                        'slug'                         => 'header-1',
                        'ehf_target_include_locations' => ['rule' => ['specifics'], 'specific' => ['post-10']],
                    ],
                    [
                        'slug'                         => 'header-3',
                        'ehf_target_include_locations' => ['rule' => ['basic-global'], 'specific' => []],
                        'ehf_target_exclude_locations' => ['rule' => ['specifics'], 'specific' => ['post-10']],
                    ],
                ],
                'footer' => [
                    [
                        'slug'                         => 'footer-1',
                        'ehf_target_include_locations' => ['rule' => ['basic-global'], 'specific' => []],
                    ]
                ]
            ],
            'home-2' => [
                'header' => [

                    [
                        'slug'                         => 'header-2',
                        'ehf_target_include_locations' => ['rule' => ['specifics'], 'specific' => ['post-11']],
                    ],
                    [
                        'slug'                         => 'header-3',
                        'ehf_target_include_locations' => ['rule' => ['basic-global'], 'specific' => []],
                        'ehf_target_exclude_locations' => ['rule' => ['specifics'], 'specific' => ['post-11']],
                    ]
                ],
                'footer' => [
                    [
                        'slug'                         => 'footer-1',
                        'ehf_target_include_locations' => ['rule' => ['basic-global'], 'specific' => []],
                    ]
                ]
            ],
            'home-3' => [
                'header' => [
                    [
                        'slug'                         => 'header-3',
                        'ehf_target_include_locations' => ['rule' => ['basic-global'], 'specific' => []],
                    ],
                ],
                'footer' => [
                    [
                        'slug'                         => 'footer-1',
                        'ehf_target_include_locations' => ['rule' => ['basic-global'], 'specific' => []],
                    ]
                ]
            ]
        ];
    }


    private function reset_header_footer() {
        $footer_args = array(
            'post_type'      => 'elementor-hf',
            'posts_per_page' => -1,
            'meta_query'     => array(
                array(
                    'key'     => 'ehf_template_type',
                    'compare' => 'IN',
                    'value'   => ['type_footer', 'type_header']
                ),
            )
        );
        $footer      = new WP_Query($footer_args);
        while ($footer->have_posts()) : $footer->the_post();
            update_post_meta(get_the_ID(), 'ehf_target_include_locations', []);
            update_post_meta(get_the_ID(), 'ehf_target_exclude_locations', []);
        endwhile;
        wp_reset_postdata();
    }

    public function set_demo_menus() {
        $main_menu = get_term_by('name', 'Main Menu', 'nav_menu');

        set_theme_mod(
            'nav_menu_locations',
            array(
                'primary'  => $main_menu->term_id,
                'handheld' => $main_menu->term_id,
            )
        );
    }

    private function set_hf($home) {
        $all_hf = $this->get_all_header_footer();
        $datas  = $all_hf[$home];
        foreach ($datas as $item) {
            foreach ($item as $object) {
                $hf = get_page_by_path($object['slug'], OBJECT, 'elementor-hf');
                if ($hf) {
                    update_post_meta($hf->ID, 'ehf_target_include_locations', $object['ehf_target_include_locations']);
                    if (isset($object['ehf_target_exclude_locations'])) {
                        update_post_meta($hf->ID, 'ehf_target_exclude_locations', $object['ehf_target_exclude_locations']);
                    }
                }
            }
        }
    }

    public function render_child_functions_php() {
        $output
            = "<?php
/**
 * Theme functions and definitions.
 */
		 ";

        return $output;
    }

    public function get_all_options(){
        $options = [];
        $options['options']   = json_decode('{"ecofa_options_blog_sidebar":"right","ecofa_options_blog_single_sidebar":"right","ecofa_options_give_page":"0","ecofa_options_give_archive_layout":"grid","ecofa_options_give_archive_column":"3","ecofa_options_give_archive_sidebar":"none","ecofa_options_give_forms_per_page":"9"}', true);
        $options['elementor']   = json_decode('{"system_colors":[{"_id":"primary","title":"Primary","color":"#139C63"},{"_id":"secondary","title":"Secondary(Heading)","color":"#3E676E"},{"_id":"text","title":"Text","color":"#333333"},{"_id":"accent","title":"Accent","color":"#002539"},{"_id":"border","title":"Border","color":"#E1E1E1"},{"_id":"lighter","title":"Lighter","color":"#8F8F8F"},{"_id":"dark","title":"Dark","color":"#000000"}],"custom_colors":[],"system_typography":[{"_id":"primary","title":"Primary","typography_typography":"custom"},{"_id":"secondary","title":"Secondary(Heading)","typography_typography":"custom"},{"_id":"tertiary","title":"Tertiary","typography_typography":"custom"},{"_id":"text","title":"Text","typography_typography":"custom"},{"_id":"accent","title":"Accent","typography_typography":"custom"}],"custom_typography":[],"default_generic_fonts":"Sans-serif","site_name":"Ecofa","site_description":"Environment Protection Nonprofits WordPress Theme","page_title_selector":"h1.entry-title","activeItemIndex":1,"active_breakpoints":["viewport_mobile","viewport_mobile_extra","viewport_tablet","viewport_tablet_extra","viewport_laptop"],"viewport_md":768,"viewport_lg":1025,"container_width":{"unit":"px","size":1290,"sizes":[]},"space_between_widgets":{"unit":"px","size":0,"sizes":[]},"body_background_background":"classic","body_background_color":"#fff","viewport_laptop":1440}', true);
        return $options;
    } // end get_all_options
}

return new Ecofa_Merlin_Config();
