<?php

class Ecofa_Give_Widget_Categories extends WP_Widget {
    public function __construct() {
        $widget_ops = array(
            'classname'                   => 'ecofa_widget_campaign',
            'description'                 => __('Display Categories Campaign', 'ecofa'),
            'customize_selective_refresh' => true,
        );
        parent::__construct('osf_widget_campaign_categories', __('Ecofa Categories Campaign', 'ecofa'), $widget_ops);
        $this->alt_option_name = 'osf_widget_campaign_categories';
    }

    public function widget($args, $instance) {
        $title = !empty($instance['title']) ? $instance['title'] : __('Campaign Categories', 'ecofa');

        echo $args['before_widget'];

        if ($title) {
            echo $args['before_title'] . $title . $args['after_title'];
        }

        $args_campaign = array(
            'taxonomy'   => 'give_forms_category',
            'orderby'    => 'name',
            'order'      => 'ASC',
            'hide_empty' => 0
        );

        $cats = get_categories($args_campaign);


        if (give_is_setting_enabled(give_get_option('categories')) && !is_wp_error($cats)) {
            ?>
            <ul>
                <?php
                foreach ((array)$cats as $cat) {
                    $term_item = get_term($cat->term_id, 'give_forms_category');
                    ?>
                    <li class="cate-item">
                        <a href="<?php echo esc_attr(get_term_link($cat->term_id, 'give_forms_category')); ?>"><?php echo $cat->name; ?></a>

                        <?php
                        if (isset($instance['count'])) {
                            echo $term_item->count;
                        }
                        ?>
                    </li>
                    <?php
                }
                ?>
            </ul>
            <?php
        }

        echo $args['after_widget'];
    }

    public function form($instance) {
        $instance = wp_parse_args((array)$instance, array('title' => ''));
        $count    = isset($instance['count']) ? (bool)$instance['count'] : false;
        ?>
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'ecofa'); ?></label>
            <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
                   name="<?php echo $this->get_field_name('title'); ?>" type="text"
                   value="<?php echo esc_attr($instance['title']); ?>"/></p>
        <input type="checkbox" class="checkbox" id="<?php echo $this->get_field_id('count'); ?>" name="<?php echo $this->get_field_name('count'); ?>"<?php checked($count); ?> />
        <label for="<?php echo $this->get_field_id('count'); ?>"><?php _e('Show post counts', 'ecofa'); ?></label>
        <br/>
        <?php
    }
}