<?php
/**
 * The template for displaying author info below posts.
 *
 * @package WordPress
 * @subpackage Twenty_Twenty_One
 * @since Twenty Twenty-One 1.0
 */

?>
<?php if ( (bool) get_the_author_meta( 'description' ) && post_type_supports( get_post_type(), 'author' ) ) : ?>
	<div class="author-bio <?php echo get_option( 'show_avatars' ) ? 'show-avatars' : ''; ?>">
        <div class="avatar-author">
            <?php echo get_avatar( get_the_author_meta( 'ID' ), '140' ); ?>
        </div>
		<div class="author-bio-content">
			<h2 class="author-title">
			<?php
			printf(
				/* translators: %s: Author name. */
				esc_html__( '%s', 'ecofa' ),
				get_the_author()
			);
			?>
			</h2><!-- .author-title -->
            <?php
            printf(
                '<a class="author-link" href="%1$s" rel="author">%2$s</a>',
                esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ),
                sprintf(
                /* translators: %s: Author name. */
                    esc_html__( '%s', 'ecofa' ),
                    get_the_author_meta('url')
                )
            );
            ?>
			<p class="author-description"> <?php the_author_meta( 'description' ); ?></p><!-- .author-description -->
		</div><!-- .author-bio-content -->
	</div><!-- .author-bio -->
	<?php
endif;
