<?php

// Exit if accessed directly.
if (!defined('ABSPATH')) {
    exit;
}

$form_id = get_the_ID(); // Form ID.

$enable_category = give_is_setting_enabled(give_get_option('categories', 'disabled'));

$form                = new Give_Donate_Form($form_id);
$goal_progress_stats = give_goal_progress_stats($form);
$income              = $goal_progress_stats['raw_actual'];
$goal                = $goal_progress_stats['raw_goal'];
$creator             = new Ecofa_Give_Creator(get_post_field('post_author', $form_id));

?>

<div class="give-list__item">
    <div class="give-card__body">
        <div class="give-card__meta">

            <h3 class="give-card__title"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>

            <?php

            if (has_excerpt($form_id)) {
                // Get excerpt from the form post's excerpt field.
                $raw_content      = get_the_excerpt($form_id);
                $stripped_content = wp_strip_all_tags(
                    strip_shortcodes($raw_content)
                );
            } else {
                // Get content from the form post's content field.
                $raw_content = give_get_meta($form_id, '_give_form_content', true);

                if (!empty($raw_content)) {
                    $stripped_content = wp_strip_all_tags(
                        strip_shortcodes($raw_content)
                    );
                }
            }

            printf('<p class="give-card__text">%s</p>', $stripped_content);

            printf(
                '<a id="give-card-%1$s" class="give-card button-dark give-card__link js-give-grid-modal-launcher" data-effect="mfp-zoom-out" href="#give-modal-form-%1$s"><i class="opal-icon-arrow-circle-right"></i><span>%2$s</span></a>',
                esc_attr($form_id),
                esc_html__('donate now', 'ecofa')
            );

            printf(
                '<div id="give-modal-form-%1$s" class="give-donation-grid-item-form give-modal--slide mfp-hide">',
                $form_id
            );
            give_get_donation_form($form_id);
            echo '</div>';
            ?>

        </div>
    </div>

    <div class="give-card__media">


        <div class="give-card__thumbnail">
            <?php printf(
                '<a id="give-card-%1$s" class="give-card" href="%2$s">',
                esc_attr($form_id),
                esc_url(get_the_permalink())
            ); ?>
            <?php the_post_thumbnail('ecofa-featured-image-large'); ?>
            </a>
        </div>

        <?php
        if ($income >= $goal) {
            printf('<div class="give-card__label success">%1$s</div>', esc_html__('Successful', 'ecofa'));
        } else {
            printf('<div class="give-card__label unsuccess">%1$s</div>', esc_html__('Unsuccessful', 'ecofa'));
        }

        $video   = get_post_meta($form_id, 'osf_give_video', true);
        $gallery = get_post_meta($form_id, 'osf_give_gallery', true);
        ?>

        <div class="opal-popup-wrapper">
            <?php if ($gallery) { ?>
                <div class="opal-image-popup">
                    <div data-ecofa-id="<?php echo esc_attr($form_id) ?>" data-toogle="ecofa-gallery">
                        <i class="opal-icon-image"></i>
                    </div>
                </div>
            <?php } ?>
            <?php if ($video) { ?>
                <div class="opal-video-popup">
                    <div data-ecofa-id="<?php echo esc_attr($form_id) ?>" data-toogle="ecofa-video">
                        <i class="opal-icon-video"></i>
                    </div>
                </div>
            <?php } ?>
        </div>

        <div class="give-card__progress">
            <?php give_show_goal_progress($form_id); ?>
        </div>

    </div><!-- end give-card__media-->
</div>
